## linda 0.2.23

=== Makefile ===
DESTDIR=""
VERSION := $(shell head -1 debian/changelog | cut -d\( -f2 | cut -d\) -f1)

install:
	install -d -m 755 $(DESTDIR)/usr/bin
	install -d -m 755 $(DESTDIR)/usr/lib/site-python/linda
	install -d -m 755 $(DESTDIR)/usr/share/linda/checks
	install -d -m 755 $(DESTDIR)/usr/share/linda/desc
	install -d -m 755 $(DESTDIR)/usr/share/linda/overrides
	install -d -m 755 $(DESTDIR)/usr/share/linda/output
	install -m 755 linda $(DESTDIR)/usr/bin
	install -m 644 *py $(DESTDIR)/usr/lib/site-python/linda
	cat parser.py | sed -e 's/VERSION/$(VERSION)/' > \
	$(DESTDIR)/usr/lib/site-python/linda/parser.py
	install -m 644 checks/*py $(DESTDIR)/usr/share/linda/checks
	$(MAKE) -C desc/po $@
	install -m 644 output/*.py $(DESTDIR)/usr/share/linda/output

clean:
	find . -name '*.py?' -o -name '.#*' -o -name '.*.swp' | xargs $(RM) -v
	$(MAKE) -C po $@

distclean: clean
	$(MAKE) -C po $@

=== po/Makefile ===
# Makefile for program source directory in GNU NLS utilities package.
# Copyright (C) 1995-1997, 2000, 2001 by Ulrich Drepper <drepper@gnu.ai.mit.edu>
#
# This file file be copied and used freely without restrictions.  It can
# be used in projects which are not available under the GNU Public License
# but which still want to provide support for the GNU gettext functionality.
# Please note that the actual code is *not* freely available.

PACKAGE = linda
prefix = /usr
exec_prefix = ${prefix}
datadir = $(prefix)/share
localedir = $(datadir)/locale
gettextsrcdir = $(prefix)/share/gettext/po
subdir = po
srcdir = .

INSTALL = /usr/bin/install -c
INSTALL_DATA = ${INSTALL} -m 644
MKINSTALLDIRS = ../mkinstalldirs

CC = gcc
GENCAT = gencat
MSGFMT = /usr/bin/msgfmt --statistics
XGETTEXT = /usr/bin/pygettext
MSGMERGE = msgmerge

POFILES =  $(wildcard *.po)
MOFILES =  $(patsubst %.po,%.mo,$(POFILES))

POTFILES = ../linda ../*.py ../checks/*.py

all: $(PACKAGE).pot $(MOFILES)

.SUFFIXES: .po .mo

.po.mo:
	$(MSGFMT) -o $@ $<

# Note: Target 'all' must not depend on target '$(srcdir)/$(PACKAGE).pot',
# otherwise packages like GCC can not be built if only parts of the source
# have been downloaded.

$(PACKAGE).pot: $(POTFILES)
	if test -f $(XGETTEXT); then \
		$(XGETTEXT) -d $(PACKAGE) \
			$(POTFILES); \
	else \
		touch $@; \
	fi

install: all
	for file in $(MOFILES); do \
                lang=`echo $$file | sed 's/\.mo//'`; \
                install -d $(DESTDIR)$(localedir)/$$lang/LC_MESSAGES/; \
                install -m 0644 $$file $(DESTDIR)$(localedir)/$$lang/LC_MESSAGES/$(PACKAGE).mo; \
        done

mostlyclean:
	rm -f core core.* *.pox $(PACKAGE).po *.new.po
	rm -fr *.o

clean: mostlyclean

distclean: clean
	rm -f *.mo $(PACKAGE).pot

update-po: Makefile
	$(MAKE) $(PACKAGE).pot
	if test "$(PACKAGE)" = "gettext"; then PATH=`pwd`/../src:$$PATH; fi; \
        cd $(srcdir); \
        catalogs='$(MOFILES)'; \
        for cat in $$catalogs; do \
          cat=`basename $$cat`; \
          lang=`echo $$cat | sed 's/\.mo$$//'`; \
          echo "$$lang:"; \
          if $(MSGMERGE) $$lang.po $(PACKAGE).pot -o $$lang.new.po; then \
            mv -f $$lang.new.po $$lang.po; \
          else \
            echo "msgmerge for $$cat failed!"; \
            rm -f $$lang.new.po; \
          fi; \
        done

=== desc/po/Makefile ===
intltool := "/usr/share/intltool-debian/intltool-"

generate:
	for i in ../*.desc ; do \
	$(intltool)extract --update \
	--type=gettext/rfc822deb $$i; done
	xgettext --output=linda-desc.pot --keyword=N_ ../*.desc.h
	$(RM) ../*.desc.h

install: generate
	for i in ../*.desc ; do \
	j=$$(echo $$i | cut -d/ -f2); \
	$(intltool)merge -r $(CURDIR) $$i \
	$(DESTDIR)/usr/share/linda/desc/$$j ; done

=== debian/changelog ===
linda (0.2.23) unstable; urgency=low

  * Also comment out the if block for exec-not-elf-or-script check.
    (Closes: #216607)

 -- Steve Kowalik <stevenk@debian.org>  Mon, 20 Oct 2003 10:16:32 +1000

linda (0.2.22) unstable; urgency=low

  * Translations:
    - Update PO files.
    - Update Catalan translation.
  * Fix typo in the manual page. (Closes: #210323)
  * Fix a spelling error in perl.desc. (Closes: #214409)
  * Files Check:
    - Fix false positive looking for CVS directories. (Closes: #216350)
    - Since file has found it fitting to stop telling which files are what
      kind of scripts, disable exec-not-elf-or-script check.
      (Closes: #213665, #215800)

 -- Steve Kowalik <stevenk@debian.org>  Sun, 19 Oct 2003 17:24:04 +1000

linda (0.2.21) unstable; urgency=low

  * Control Parsing:
    - Strip whitespace from the RHS of parsed lines. (thanks, Adam Conrad)
  * Options:
    - Kill the -s option, it really served no useful purpose.
      (Closes: #207591)
  * Debconf Check:
    - Actually reference a string to check. (Closes: #206985)

 -- Steve Kowalik <stevenk@debian.org>  Mon,  1 Sep 2003 17:42:12 +1000

linda (0.2.20) unstable; urgency=low

  * StandardsVersion Check:
    - Policy 3.6.1 has been uploaded.
  * Update to Standards-Version 3.6.1; no changes needed.

 -- Steve Kowalik <stevenk@debian.org>  Sat, 23 Aug 2003 17:27:43 +1000

linda (0.2.19) unstable; urgency=low

  * Also {Build-,}Depend on python (<< 2.4). (Closes: #205279)
  * .desc parsing:
    - Only delete the last entry if it's empty. (Closes: #197260)
  * Debconf Check:
    - Ignore case when looking for the Description header in debian/templates
      files. (Closes: #202624)
  * Files Check:
    - Bitch about CVS and .svn directories contained in packages.
      (Closes: #189779)
    - Ooops. Use the correct variable for common.control.

 -- Steve Kowalik <stevenk@debian.org>  Thu, 14 Aug 2003 21:08:31 +1000

linda (0.2.18) unstable; urgency=low

  * Fix FTBFS by using /usr/share/intltool-debian/intltool-{extract,merge}
    instead.
  * Jump to using python 2.3.
    - Stop Depending on, and using optik, and use optparse instead.
      (Closes: #204911)
  * Also exclude .svn directories from the doc copy.

 -- Steve Kowalik <stevenk@debian.org>  Tue, 12 Aug 2003 11:33:12 +1000

linda (0.2.17) unstable; urgency=low

  * Standards Version Check:
    - Policy 3.6.0 is now valid. 

 -- Steve Kowalik <stevenk@debian.org>  Thu, 10 Jul 2003 17:52:15 +1000

linda (0.2.16) unstable; urgency=low

  * Unpacking:
    - Rewrite level 2 source unpacking.
      + This also (unintentionally) fixes a bug that you can't unpack
        tarballs with +'s in the directory name. (Closes: #200326)
  * Binary Check:
    - Rename the first of 2 unstripped-binary to not-quite-stripped-binary.
  * Changes Check:
    - Rename unknown-component to unknown-component-changes.
  * Control Check:
    - Change the maintainer e-mail address regex. (Closes: #178764)
  * UDebBinary Check:
    - Move pkg-should-be-arch-any to udeb-pkg-should-be-arch-any.

 -- Steve Kowalik <stevenk@debian.org>  Tue,  8 Jul 2003 15:24:51 +1000

linda (0.2.15) unstable; urgency=low

  * The "Hrm. Motivation? What's that mean?" release.
  * Unpacking, Checking and VersionCompare classes:
    - Just pass for the exceptions.
  * Unpacking:
    - Stop referencing base_dir. (Closes: #199139) (thanks, Tommi Virtanen) 
  * Binary Check:
    - Tighten the regex for debug packages. Again. (Closes: #182032) (Again)
    - Ignore gcc-lib files, they're internal. (Closes: #191744)
  * ControlFiles Check:
    - Skip on lines that start with comments, or contain 'echo' or 'printf'.
      Better ways to do this that don't involve a 30 character regex are of
      course welcome. (Closes: #192301)
  * Debconf Check:
    - Ignore commented out lines in maintainer scripts. (Closes: #191256)
  * Debhelper Check:
    - Assume that Build-Depending on cdbs is enough to pull in debhelper.
      (Closes: #195565)
    - Rewrite part of this check to use a dict rather than 6 variables, and
      fix up some ifs to be boolean.
    - Further rewrite part of this check to use make -nf rather than parse
      the makefile by hand. (thanks, Bastian Kleineidam)

 -- Steve Kowalik <stevenk@debian.org>  Sat, 28 Jun 2003 22:36:34 +1000

linda (0.2.14) unstable; urgency=low

  * StandardsVersion Check:
    - Handle 3.5.10. 

 -- Steve Kowalik <stevenk@debian.org>  Sat, 17 May 2003 23:27:06 +1000

linda (0.2.13) unstable; urgency=low

  * Common functions:
    - Whoops. Add kde section to aps_not_vaild. (Closes: #192544) 

 -- Steve Kowalik <stevenk@debian.org>  Fri,  9 May 2003 11:02:03 +1000

linda (0.2.12) unstable; urgency=low

  * Common functions:
    - Add the 6 new sections to aps_not_valid. (thanks, James Troup)
  * Changes and Control Check:
    - Update long description to list new sections.
  * Files Check:
    - Add missing brackets. (Closes: #189829)

 -- Steve Kowalik <stevenk@debian.org>  Fri,  2 May 2003 18:18:51 +1000

linda (0.2.11) unstable; urgency=low

  * Documentation Check:
    - Fix slight bug in my regex for manpage directories. (Closes: #189678) 

 -- Steve Kowalik <stevenk@debian.org>  Sun, 20 Apr 2003 01:10:23 +1000

linda (0.2.10) unstable; urgency=low

  * The "brown-paper bag" release.
  * Binary Check:
    - Add the missing closing bracket.
  * ControlFiles Check:
    - Allow whitespace before (/var)/tmp.
  * Changelog Check:
    - Define urgency.
  * Files Check:
    - Rewrite the GPL blurb text.

 -- Steve Kowalik <stevenk@debian.org>  Sat, 19 Apr 2003 00:12:02 +1000

linda (0.2.9) unstable; urgency=low

  * Unpacking:
    - Remove duplicates from the list we'll run file over.
    - Little more debugging. Let's make level 3 debugging even more painful.
    - Backslash $'s before we run file.
  * Binary Check:
    - Stop looking for _g in the unstripped "debugging" binary.
      (Closes: #182032)
  * Changelog Check:


=== debian/control ===
Source: linda
Priority: optional
Section: devel
Maintainer: Steve Kowalik <stevenk@debian.org>
Build-Depends-Indep: python (>= 2.3), python (<< 2.4), debhelper (>= 4.0.0), intltool-debian
Standards-Version: 3.6.1

Package: linda
Architecture: all
Depends: python (>= 2.3), python (<< 2.4), binutils, file, dash, groff-base, fixincludes
Recommends: debian-policy, figlet
Suggests: binutils-multiarch
Provides: lintian-python
Description: Debian package checker, not unlike lintian
 Linda is a Debian package checker, much like lintian, that
 runs some rudimentary checks over source and binary packages
 to see if they comply to Policy.

=== debian/rules ===
#!/usr/bin/make -f

build: build-stamp
build-stamp:
	dh_testdir
	touch build-stamp

clean:
	rm -rf build-stamp install-stamp
	rm -f debian/copyright
	$(MAKE) clean
	dh_clean

install: build-stamp install-stamp
install-stamp:
	$(MAKE) install DESTDIR="$(CURDIR)/debian/linda"
	ln -s $(CURDIR)/copyright $(CURDIR)/debian/copyright
	$(MAKE) -C po install DESTDIR="$(CURDIR)/debian/linda"
	touch install-stamp

binary-indep: build install
	dh_testroot
	dh_installdirs
	dh_installdocs -XCVS -X.svn
	dh_installman
	dh_installchangelogs
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep
.PHONY: build clean binary-indep binary install

## linda 0.3.4ubuntu1

=== Makefile ===
DESTDIR=""
VERSION := $(shell head -1 debian/changelog | cut -d\( -f2 | cut -d\) -f1)

install:
	install -d -m 755 $(DESTDIR)/usr/bin
	install -d -m 755 $(DESTDIR)/usr/lib/site-python/linda
	install -d -m 755 $(DESTDIR)/usr/lib/site-python/linda/parser
	install -d -m 755 $(DESTDIR)/usr/share/linda/checks
	install -d -m 755 $(DESTDIR)/usr/share/linda/data
	install -d -m 755 $(DESTDIR)/usr/share/linda/output
	install -d -m 755 $(DESTDIR)/usr/share/linda/overrides
	install -m 755 linda $(DESTDIR)/usr/bin
	install -m 644 *py $(DESTDIR)/usr/lib/site-python/linda
	install -m 644 parser/*py $(DESTDIR)/usr/lib/site-python/linda/parser
	cat $(DESTDIR)/usr/lib/site-python/linda/parser/clparser.py | \
	sed -e 's/VERSION/$(VERSION)/' > \
	$(DESTDIR)/usr/lib/site-python/linda/parser/clparser.py.new
	mv $(DESTDIR)/usr/lib/site-python/linda/parser/clparser.py.new \
	$(DESTDIR)/usr/lib/site-python/linda/parser/clparser.py
	install -m 644 data/*data $(DESTDIR)/usr/share/linda/data
	install -m 644 checks/*py $(DESTDIR)/usr/share/linda/checks
	install -m 644 output/*py $(DESTDIR)/usr/share/linda/output

test:
	PYTHONPATH=$(DESTDIR)/usr/lib/site-python tests/run_tests.py
	find . -name '*.py?' | xargs $(RM)

clean:
	find . -name '*.py?' -o -name '.#*' -o -name '.*.swp' | xargs $(RM)
	$(MAKE) -C po $@

distclean: clean
	$(MAKE) -C po $@

=== debian/changelog ===
linda (0.3.4ubuntu1) warty; urgency=low

  * Drop Build-Depends: figlet to let figlet move to universe.
  * Do not run figlet unit test.

 -- Fabio M. Di Nitto <fabbione@fabbione.net>  Wed, 06 Oct 2004 07:53:32 +0200

linda (0.3.4) unstable; urgency=low

  * Checker:
    - Stop Checker being instantiated for every file. Instantiate it once, 
      and call a check function for every file. Move data_files from a local
      function to a class variable, and stop it being overwritten every time.
      This preserves the seen flag for long description, meaning they only get
      shown once. (Closes: #182033)
  * Control Parser:
    - Put the original line into the hash, with an -orig suffix.
  * Command-line parser:
    - Accept -I, --informational as an argument, and print a note rather than
      dying a messy death with a 24 line usage message. (Closes: #233879)
    - Add a new argument: -P or --profiling that prints out some profiling
      stats on exit.
  * RFC822 Parser:
    - Count the number of empty stanzas we encounter.
  * Test Suite:
    - Fix a small issue in three test cases that were leaving files in TMPDIR.
  * Changelog Check:
    - Check that we are dealing with a link first, and only if we aren't
      check that the changelog isn't compressed. (Closes: #252708)
  * Debconf Check:
    - Implement the versioned debconf dependancy check. (Closes: #180643)
    - Warn about the number of empty stanzas in the templates file.
      (Closes: #230708)
  * Debhelper Check:
    - Don't just parse commands out of the binary targets and its 
      dependencies in debian/rules, now look everywhere, since that's where 
      debhelper might be hiding. (Closes: #252158)
  * Documentation Check:
    - Don't try and read a manpage that is a symlink.
  * Example Files Check:
    - Tighten the regular expression for dh-make example files.
      (Closes: #250199)
  * Files Check:
    - Don't try and stat the mtime of a symlink.
    - Correctly check for a symlink when checking the permissions of a file.
      (Closes: #251384, #255273)
  * UDebControl Check:
    - Complain if the Depends or Recommends field contains a pipe symbol.
      (Closes: #231292)
  
 -- Steve Kowalik <stevenk@debian.org>  Fri, 25 Jun 2004 17:25:11 +1000

linda (0.3.3) unstable; urgency=low

  * Files Check:
    - Actually call the README.Debian tests.
    - Check for files which are considered too old. (Closes: #204800)
  * Parsers:
    - Write a robust parser to replace file_to_{packagename,version}.
      (Closes: #230986)
  * Tests:
    - Write a test case that checks the keys in the checks files versus what is
      contained in the data files and the po files. (Closes: #247710)
    - Also fix PrintErrors to not die when the tag doesn't exist in the data file.
    - Also write a test case for Output.
  * Translation:
    - Fix some typos in the English po file. (Closes: #248031)
      (thanks, Florian Ernst)
    - Update the German po file. (Closes: #247693) (thanks, Florian Ernst)
  
 -- Steve Kowalik <stevenk@debian.org>  Tue, 18 May 2004 22:57:21 +1000

linda (0.3.2) unstable; urgency=low

  * Remove a stray arch file. (Closes: #245775)
  * Dependancies:
    - Remove groff-base, and add man-db to Depends and Build-Depends.
      (Closes: #246768)
  * Control Parser:
    - Accept whitespace after the left paren for specifying a version.
  * Binary Check:
    - Don't special case filenames which contain '/lib/modules', instead 
      don't complain about ELF LSB relocatables for binary-note-or-comment,
      binary-libc6, unstripped-binary, and shared-binary. (Closes: #245890)
    - Drop pkg-should-be-arch-all. It is extremly difficult to correctly
      determine if a package should be Architecture: all.
      (Closes: #245888, #246761)
  * DpkgVer:
    - Deal with comparing non-native and native versions. (Closes: #223021)
    - Implement .is_native() method.
  * Overrides:
    - Deal with data that is thrown to a regex that isn't a string.
      (Closes: #246400)
  * CDBS Check:
    - 'include /usr/share/cdbs' will never be in any CDBS-using rules file,
      correct the check. (Closes: #245885)
  * Changelog Check:
    - Warn when we switch from native to non-native version numbers, or the
      converse.
  * Control Check:
    - Warn about packages that listed in both Depends or either of Suggests
      or Recommends. (Closes: #235354)
  * Debhelper Check:
    - Deal with debian/rules files that don't contain a binary target.
      (Closes: #246287)
    - Don't complain about non-use of debhelper if we find the cdbs
      debhelper.mk include in debian/rules.
    - Don't (incorrectly) look for a dependancy on cdbs when looking for
      debhelper's version. (Closes: #246400)
  * Documentation Check:
    - Actually put whatis-parse-failed-on-manpage in the data file.
    - Don't strip off '.[0-9]' for binary files. (Closes: #245776, #246785)
    - Deal with manual pages that aren't just section 3, such as section 3pm.
      (Closes: #246012)
  * Library Check:
    - Put a stop to section-not-libs and package-not-start-libs being so
      damn overzealous. (Closes: #245892, #246018, #246786)
  
 -- Steve Kowalik <stevenk@debian.org>  Mon,  3 May 2004 23:09:46 +1000

linda (0.3.1) unstable; urgency=low

  * Building:
    - Put figlet, groff-base, file in the Build-Depends, since passing the
      test suite is required for building. (Closes: #245407)
    - Stop .arch-ids being installed.
  * Checker:
    - Actually deal with being thrown .changes files. (Closes: #245316)
    - Don't add tarballs to the file list.
  * Output:
    - Bend the long description to our nefarious purposes by means of the
      dynamic duo of join and map.
  * Binary Check:
    - Ignore files who files contain '/lib/modules' in their path for 
      unstripped-binary, binary-libc6 and shared-binary. (Closes: #205883)
    - Also ignore files that contain '/lib/modules' in their path for
      binary-note-or-comment.


=== debian/control ===
Source: linda
Priority: optional
Section: devel
Maintainer: Steve Kowalik <stevenk@debian.org>
Build-Depends-Indep: python (>= 2.3.1), python (<< 2.4), debhelper (>= 4.0.0), file, dash, man-db
Standards-Version: 3.6.1

Package: linda
Architecture: all
Depends: python (>= 2.3.1), python (<< 2.4), binutils, file, dash, man-db
Recommends: debian-policy, figlet
Suggests: binutils-multiarch
Provides: lintian-python
Conflicts: file (= 4.04)
Description: Debian package checker, not unlike lintian
 Linda is a Debian package checker, much like lintian, that
 runs some rudimentary checks over source and binary packages
 to see if they comply to Policy.

## linda 0.3.8ubuntu2

=== Makefile ===
--- 
+++ 
@@ -32,3 +32,4 @@
 distclean: clean
 	$(MAKE) -C po $@
 
+.PHONY: install test clean distclean

=== debian/changelog ===
linda (0.3.8ubuntu2) hoary; urgency=low

  * Conditionally import the profile module (closes: #294522, Ubuntu #6401).

 -- Matthias Klose <doko@ubuntu.com>  Thu, 10 Feb 2005 13:47:27 +0100

linda (0.3.8ubuntu1) hoary; urgency=low

  * Resync with Debian (only python2.3->2.4 transition remains.)

 -- LaMont Jones <lamont@canonical.com>  Wed,  5 Jan 2005 18:37:00 -0700

linda (0.3.8) unstable; urgency=high

  * Checker:
    - Add missing self to error printing call. (Closes: #279021)
  * Collector:
    - Deal with hard links. (Closes: #276169)
  * Command line parser:
    - -c is used to specify a file and not a directory.
  * Common functions:
    - iterate_dir did not add symlinks to files that don't exist, which may
      happen from time to time.
  * Config file Parser:
    - Allow types to be specified in the config file.
  * Control Parser:
    - Deal with broken control files that have lines ending with a comma and
      lines that don't contain a comma. Of course packages that contain
      broken control files are all the package checkers fault.
      (Closes: #276161)
    - Actually split on space in the control parser. (Closes: #281211)
  * Override Parser:
    - Tell which file is badly-formed. (Closes: #282377)
  * Packaging:
    - Kill figlet from Build-Depends and drop the Recommends to Suggests.
      Linda now checks for the existance of the figlet command before 
      using it, and figlet is not required for passing the testsuite, due
      to figlet being moved to non-free.
      (thanks, Steve Langasek)
  * RFC822 Parser:
    - Deal with lines that don't have whitespace after the first colon.
      (Closes: #276166)
  * Testsuite:
    - Compare the number of arguments a check passes, as opposed to how many
      arguments the short description is expecting. (Closes: #276171, #276179)
    - Make the testsuite a little more robust if one of the tests that 
      chdir()'s fails.
  * Translations:
    - Update Catalan po file. (thanks, Jordi Mallach)
  * Unpacking:
    - Catch the potiental ExtCmdException that will be thrown if patch fails.
    - Deal with the situation that unpacking an orig tarball that contains
      one top-level item that isn't a directory. (Closes: #275174)
    - Notice that shutil.move can't deal with moving a directory into another
      directory and switch to using os.rename. (Closes: #276170)
  * Changelog Check:
    - Deal with package names that contain a +. (Closes: #276176, #279628)
    - Remove a debug print to avoid a FutureWarning caused by gzip.
  * ConfigFile Check:
    - Don't complain if a symlink isn't listed in control/conffiles.
      (Closes: #272873)
  * Debhelper Check:
    - Complain if dh_python is used without a python-dev build dependancy.
      (Closes: #278291)
  * Documentation Check:
    - Fix the long description for no-manual-for-binary. (Closes: #277433)
    - Check that devhelp files actually exist where they are expected to be.
      (Closes: #273310)
  * ExampleFiles Check:
    - Don't match if the next char after 'debian/ex' is a word char.
      (Closes: #282188)
    - Only bitch if the file is really 'debian/files'. (Closes: #282389)
  * Files Check:
    - Rewrite the descriptions for vercon-dir-in-package. Also, print out a
      pretty representation of which tool we think created the directory.
      (thanks, Angus Lees)
    - Downgrade usr-lib-in-arch-all to a Warning. You know, the point of a
      package checker is warn about things it thinks are broken, *not*
      to sprinkle hard-coded exceptions throughout the code.
      (Closes: #279626)
  * Shebang Check:
    - If the regex to find a shebang line doesn't find anything, deal, and
      don't just blindly use the sre object. (Closes: #276168)
  
 -- Steve Kowalik <stevenk@debian.org>  Wed,  8 Dec 2004 12:49:15 +1100

linda (0.3.7ubuntu3) hoary; urgency=low

  * Build for python2.4

 -- Matthias Klose <m@klose.in-berlin.de>  Thu, 16 Dec 2004 09:48:02 +0100

linda (0.3.7ubuntu2) hoary; urgency=low

  * Undo wrong merge from resynchronisation (closes: #4145).

 -- Matthias Klose <m@klose.in-berlin.de>  Fri,  3 Dec 2004 00:01:15 +0000

linda (0.3.7ubuntu1) hoary; urgency=low

  * Resynchronise with Debian.

 -- Scott James Remnant <scott@canonical.com>  Wed, 27 Oct 2004 20:10:05 +0100

  linda (0.3.7) unstable; urgency=high
  
    * Collector:

linda (0.3.7) unstable; urgency=high

  * Collector:
    - Sigh. Collector has stupidly assumed that filenames don't contain 
      spaces. Rewrite the binary parse method to deal with files that contain
      or start with a space. (Closes: #270325, #271518)
  * Control Parser:
    - Start attempting to catch errors during the parsing of a control file,
      so that we can say what went wrong, rather than dying with a large
      traceback. (Closes: #268863)
  * Changelog Check:
    - Fix typo in the long description of next-ver-less-than-prev.
      (thanks, Jean-Luc Coulon)
  * Control Check:
    - Rename char-forbidden-rfc822 to dangerous-char-in-control.
      (Closes: #270132)
  * Copyright Check:
    - Move probable-dh-make-template from files.data to where it belongs in
      copyright.data. (Closes: #269353)
  * Unpacking:
    - Stop importing (and using) traceback.
  
 -- Steve Kowalik <stevenk@debian.org>  Sat, 18 Sep 2004 12:54:22 +1000

linda (0.3.6) unstable; urgency=low

  * Control Check:
    - Section is now an array, so don't check it as a string.
      (Closes: #265731)

 -- Steve Kowalik <stevenk@debian.org>  Wed, 25 Aug 2004 13:10:59 +1000

linda (0.3.5) unstable; urgency=low

  * ErrDicts:
    - Implement a .clear() method.
  * Changelog Check:
    - Deal with packages that contain both a changelog.gz and a 
      changelog.Debian.gz WRT wrong-changelog-name. (Closes: #263577)
  * Control Check:
    - Accept underscores in the first part of a mail address.
      (Closes: #261428)
  * Documentation Check:
    - Warn if only a non-English manual page is present. (Closes: #259225)


=== debian/control ===
Source: linda
Priority: optional
Section: devel
Maintainer: Steve Kowalik <stevenk@debian.org>
Build-Depends-Indep: python (>= 2.4), python (<< 2.5), debhelper (>= 4.2.28), file, dash, man-db
Standards-Version: 3.6.1

Package: linda
Architecture: all
Depends: python (>= 2.4), python (<< 2.5), binutils, file, dash, man-db
Recommends: debian-policy
Suggests: binutils-multiarch, figlet
Provides: lintian-python
Conflicts: file (= 4.04)
Description: Debian package checker, not unlike lintian
 Linda is a Debian package checker, much like lintian, that
 runs some rudimentary checks over source and binary packages
 to see if they comply to Policy.

=== debian/rules ===
#!/usr/bin/make -f

build: build-stamp
build-stamp:
	dh_testdir
	touch $@

clean:
	$(RM) -r build-stamp install-stamp test-stamp
	$(RM) debian/copyright
	$(MAKE) $@
	$(MAKE) -C po $@
	$(RM) po/*.mo
	dh_clean

test: test-stamp
test-stamp: install-stamp
	$(MAKE) test DESTDIR="$(CURDIR)/debian/linda"
	touch $@

install: build-stamp install-stamp
install-stamp:
	$(MAKE) install DESTDIR="$(CURDIR)/debian/linda"
	ln -s $(CURDIR)/copyright $(CURDIR)/debian/copyright
	$(MAKE) -C po install DESTDIR="$(CURDIR)/debian/linda"
	touch $@

binary-indep: build-stamp install-stamp test-stamp
	dh_testroot
	dh_installdirs
	dh_installdocs -XCVS -X.svn -X.arch-ids
	dh_installman
	dh_installchangelogs
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep
.PHONY: build clean binary-indep binary install test

## linda 0.3.13.sarge.1

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 DESTDIR=""
-VERSION := $(shell head -1 debian/changelog | cut -d\( -f2 | cut -d\) -f1)
+VERSION := $(shell head -n 1 debian/changelog | cut -d\( -f2 | cut -d\) -f1)
 
 install:
 	install -d -m 755 $(DESTDIR)/usr/bin

=== po/Makefile ===
--- 
+++ 
@@ -28,7 +28,7 @@
 POFILES =  $(wildcard *.po)
 MOFILES =  $(patsubst %.po,%.mo,$(POFILES))
 
-POTFILES = ../linda ../*.py ../checks/*.py
+POTFILES = ../linda ../*.py ../checks/*.py ../parser/*.py ../output/*.py
 
 all: $(PACKAGE).pot $(MOFILES)

=== debian/changelog ===
linda (0.3.13.sarge.1) testing-proposed-updates; urgency=medium

  * Command-line arguments:
    - Add -S, which doesn't drop root privledges when running as root.
  * Testsuite:
    - Call linda with -S in the endtoend tests. (Closes: #307183)

 -- Steve Kowalik <stevenk@debian.org>  Sun, 15 May 2005 23:05:54 +1000

linda (0.3.13) unstable; urgency=low

  * Packaging:
    - Build-Depend on python, as opposed to python >= 2.31, << 2.4.
    - Convert changelog to proper UTF8.
  * MenuParser:
    - Deal with lines that don't contain a field. (Closes: #303530)
      (thanks, Lars Wirzenius)
  * Checks:
    - Print out a traceback if -T is specified and a check is interrupted.
  * ChangelogCheck:
    - Don't complain about HTML only changelog if changelog{.gz,} exists.
      (Closes: #297750)
  * DocumentationCheck:
    - Don't overzealously split off extensions, and don't split off 
      multiple number extensions for manual pages.
      (Closes: #303134, #303644, #303783)
  * MenuCheck:
    - Deal with commands that contain arguments.
    - Complain about unknown or top-level sections.

 -- Steve Kowalik <stevenk@debian.org>  Sun, 10 Apr 2005 12:09:42 +1000

linda (0.3.12) unstable; urgency=low

  * Rebuild, since the tarball picked up all the svn stuff.

 -- Steve Kowalik <stevenk@debian.org>  Mon,  4 Apr 2005 10:31:28 +1000

linda (0.3.11) unstable; urgency=medium

  * Copyright:
    - Update year (finally).
  * Building:
    - Use head -n 1, not head -1 in the Makefile.
    - Switch to using dh_python.
  * Manual page:
    - Refer to data files, rather than descs.
  * ArchParser:
    - Use funcs.run_external_cmd rather than os.popen.
    - Use filter() rather than a for loop.
    - If dpkg-architecture --help doesn't give us a list of Debian arches,
      run dpkg-architecture -L instead. (thanks, Scott James Remnant)
  * CLParser:
    - Drop 'X' from the default types list.
    - Print a warning when enabling -t X. (Closes: #282838)
  * Checker:
    - Deal if a .data file doesn't exist.
  * DebianControlParser:
    - Deal with multi-line fields other than Description. (Closes: #289066)
  * MenuParser:
    - New, parses the menu format files.
  * RFC822Parser:
    - Also assume that lines only containing whitespace are blank lines, used
      to seperate stanzas.
  * UnixPermParser:
    - The function name for printing out strings is __repr__, not __str__.
  * Output:
    - Only call mygettext.translation once.
  * BinaryCheck:
    - Correct typo in shared-binary. (Closes: #300263)
    - Skip both LSB and MSB relocatables in various tests. (Closes: #301392)
    - Rewrite the message for arch-dep-in-usr-share. (Closes: #301929)
      (thanks, Adeodato Simó)
  * ChangelogCheck:
    - Don't try and find the file size of a symlink when the target may not
      exist. (Closes: #302722)
  * ControlFilesCheck:
    - Check for [[ or ]] in maintainer scripts when the interpreter isn't 
      bash. (Closes: #296239)
  * DocumentationCheck:
    - Fix the completly broken doc-base check. (Closes: #296859)
      + doc-base is the last entry in the path, not the filename.
      + The Files: field can list multiple files.
      + Don't complain that a file doesn't exist when it does just because
        it doesn't use a glob.
    - Try harder to remove extensions from the manual page filename.
      (Closes: #296860)
  * FilesCheck:
    - Don't complain about binaries under /usr/games that aren't 755.
      (Closes: #290686)
  * LibraryCheck:
    - Check that libdir in a .la file is the same as the path of the .la
      file. (thanks, Henrique de Moraes Holschuh)
  * MenuCheck:
    - New; check the menu files contained in a package.

 -- Steve Kowalik <stevenk@debian.org>  Sun,  3 Apr 2005 23:46:36 +1000

linda (0.3.10) unstable; urgency=critical

  * Linda:
    - Also shift pstats down to the new profile bit, since it is also 
      affected.

 -- Steve Kowalik <stevenk@debian.org>  Sat, 12 Feb 2005 22:38:06 +1100

linda (0.3.9) unstable; urgency=high

  * Translations:
    - Update French po file. (Closes: #269217) (thanks, Jean-Luc Coulon)
  * Unpacking:
    - Add support for source overrides. These get parsed and merged in at the
      end of level 2 source unpacking, but the only check run before that is
      standards-version. (Closes: #282381)
    - Set LANG to C when calling tar for the level two binary unpack.
      (Closes: #292670)
  * Linda:
    - Don't import profile at the same time as the rest of the modules. Only
      attempt to import it if profiling is switched on, and deal if the module
      can't be imported. (Closes: #294522)
  * Debhelper Check:
    - Check for a python build-dep as well as python-dev. (Closes: #289535)
  * Files Check:
    - Ignore files underneath /usr/lib/mime for usr-lib-in-arch-all.
      (Closes: #288801)
  * Perl Check:
    - Stop checking against source package, and tighten the regular
      expression which decides that we are checking a perl module
      package. (thanks, Marc Brockschmidt)

 -- Steve Kowalik <stevenk@debian.org>  Fri, 11 Feb 2005 22:30:42 +1100

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Priority: optional
 Section: devel
 Maintainer: Steve Kowalik <stevenk@debian.org>
-Build-Depends-Indep: python (>= 2.4), python (<< 2.5), debhelper (>= 4.2.28), file, dash, man-db
+Build-Depends-Indep: python, debhelper (>= 4.0.0), file, dash, man-db
 Standards-Version: 3.6.1
 
 Package: linda
 Architecture: all
-Depends: python (>= 2.4), python (<< 2.5), binutils, file, dash, man-db
+Depends: ${python:Depends}, binutils, file, dash, man-db
 Recommends: debian-policy
 Suggests: binutils-multiarch, figlet
 Provides: lintian-python

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,4 @@
-#!/usr/bin/make -f
+#!/usr/bin/make -f 
 
 build: build-stamp
 build-stamp:
@@ -28,9 +28,10 @@
 binary-indep: build-stamp install-stamp test-stamp
 	dh_testroot
 	dh_installdirs
-	dh_installdocs -XCVS -X.svn -X.arch-ids
+	dh_installdocs -X.svn
 	dh_installman
 	dh_installchangelogs
+	dh_python
 	dh_compress
 	dh_fixperms
 	dh_installdeb

## linda 0.3.15

=== debian/changelog ===
linda (0.3.15) unstable; urgency=low

  * Makefile:
    - Use dpkg-parsechangelog rather than head -n 1 debian/changelog.
  * Collector, MakefileParser:
    - Use re.compile().
  * Output:
    - It seems I can't just print a Unicode string even though I have
      declared its charset, so encode it in that charset.
      (Closes: #309884)
  * Translations:
    - Update German translation. (Closes: #314152) (thanks, Jens Seidel)
  * MenuParser:
    - Rewrite the guts of the parser to only split on known fields, which
      makes dealing with ='s in the data *much* easier to handle.
  * LibraryCheck:
    - The shlibs-sover-mismatch symlink finding code was matching on other
      filenames so append a '.' to stop that. (Closes: #313587)
  * MenuCheck:
    - Also check /usr/share/menu for menu files.
    - Complain if any menu files are installed into /usr/lib/menu.
    - Actually run the Section check.
    - Skip commands that invoke sh. (Closes: #314495)
  * StandardsVersionCheck:
    - Policy 3.6.2 has been uploaded. (Closes: #314880)

 -- Steve Kowalik <stevenk@debian.org>  Thu, 23 Jun 2005 10:02:21 +1000

linda (0.3.14) unstable; urgency=medium

  * Manual Page:
    - Actually run a spell checker over it. (*blush*)
    - Mention types overrides under OVERRIDES.
  * Error printing:
    - Complain if the tag does not exist in the data file.
  * Libchecks:
    - Print out the filename of the registered checks at debug level 4.
  * Packaging:
    - Update long Description. (Closes: #304325) (thanks, Emanuele Rocca)
    - Append the short and long descriptions to linda.pot. (Closes: #305059)
  * Command-line arguments:
    - Add -S, which doesn't drop root privledges when running as root.
  * Testsuite:
    - Call linda with -D and -S in the endtoend tests. (Closes: #307183)
  * Output:
    - Put strings grabbed from gettext into unicode strings encoded in the
      right charset. (Closes: #306047)
  * Overrides:
    - If an error doesn't pass any data, using a Data header in an override
      file made it not match, so fix that. (Closes: #306046)
  * Figlet Output:
    - Actually make it work by correcting a typo in bootstrap.
  * BinaryCheck:
    - Add [-_] to the start of checking if a package name is considered to be
      debug, and smush the checks that are affected by debug together.
      (Closes: #305930)
    - Correct the short description of stripped-binary-not.
    - Rewrite the .note and .comment check to not be so dumb.
    - Don't complain about no depends line if the package contains any ELF
      relocatables. (Closes: #308137)
  * ChangelogCheck:
    - Sprinkle in a little re.compile().
  * LibraryCheck:
    - First attempt to check shlibs control files.

 -- Steve Kowalik <stevenk@debian.org>  Sun, 15 May 2005 12:31:24 +1000

=== debian/control ===
--- 
+++ 
@@ -16,3 +16,8 @@
  Linda is a Debian package checker, much like lintian, that
  runs some rudimentary checks over source and binary packages
  to see if they comply to Policy.
+ .
+ Linda has a greater featureset than Lintian, providing
+ (among other things) English descriptions, fully
+ translatable strings, and can print using different formats.
+

## linda 0.3.17-0ubuntu1

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 DESTDIR=""
-VERSION := $(shell head -n 1 debian/changelog | cut -d\( -f2 | cut -d\) -f1)
+VERSION := $(shell dpkg-parsechangelog | grep Version | cut -d' ' -f2)
 
 install:
 	install -d -m 755 $(DESTDIR)/usr/bin
@@ -22,8 +22,10 @@
 	install -m 644 output/*py $(DESTDIR)/usr/share/linda/output
 
 test:
+	install -m 644 munge_po $(DESTDIR)/usr/lib/site-python/munge_po.py
 	PYTHONPATH=$(DESTDIR)/usr/lib/site-python tests/run_tests.py
 	find . -name '*.py?' | xargs $(RM)
+	$(RM) $(DESTDIR)/usr/lib/site-python/munge_po.py
 
 clean:
 	find . -name '*.py?' -o -name '.#*' -o -name '.*.swp' | xargs $(RM)

=== po/Makefile ===
--- 
+++ 
@@ -19,8 +19,6 @@
 INSTALL_DATA = ${INSTALL} -m 644
 MKINSTALLDIRS = ../mkinstalldirs
 
-CC = gcc
-GENCAT = gencat
 MSGFMT = /usr/bin/msgfmt --statistics
 XGETTEXT = /usr/bin/pygettext
 MSGMERGE = msgmerge
@@ -30,16 +28,12 @@
 
 POTFILES = ../linda ../*.py ../checks/*.py ../parser/*.py ../output/*.py
 
-all: $(PACKAGE).pot $(MOFILES)
+all: $(MOFILES) $(PACKAGE).pot
 
 .SUFFIXES: .po .mo
 
 .po.mo:
 	$(MSGFMT) -o $@ $<
-
-# Note: Target 'all' must not depend on target '$(srcdir)/$(PACKAGE).pot',
-# otherwise packages like GCC can not be built if only parts of the source
-# have been downloaded.
 
 $(PACKAGE).pot: $(POTFILES)
 	if test -f $(XGETTEXT); then \
@@ -48,6 +42,7 @@
 	else \
 		touch $@; \
 	fi
+	cd .. && PYTHONPATH=$(DESTDIR)/usr/lib/site-python LANGUAGE=english ./munge_po >> po/$@
 
 install: all
 	for file in $(MOFILES); do \

=== debian/changelog ===
linda (0.3.17-0ubuntu1) dapper; urgency=low

  * Teach Linda's custom gettext routines how to find '.mo' translation
    files in Ubuntu's '/usr/share/locale-langpack' location.
    01-gettext-langpacks.diff
  * Deal with assert failure on ELFs having a slightly different signature
    in the newer build environment.
    02-elf-information.diff

 -- Paul Sladen <ubuntu@paul.sladen.org>  Wed, 01 Mar 2006 14:13:27 +0000

linda (0.3.17) unstable; urgency=low

  * Linda:
    - Spit out running as root error to stderr.
    - Switch to using gettext.install, as well as moving the gettext
      initialisation into the modules. (Closes: #318561, #318578, #340032)
      (thanks, Joe Wreschnig)
    - As a consequence, remove debugging from mygettext, and kill 
      ourselves with exit status 5 if we can't find a .mo file on startup.
    - Document the change in meaning for exit status 5.
    - If we can't load modules, don't print out translated messages, as they
      are printed far too early for us to have correct charset information.
    - Depend on dpkg-dev. (Closes: #324674)
  * Collector:
    - If file dies, don't kill ourselves in sympathy. (Closes: #338850)
  * Funcs:
    - Rewrite run_external_cmd to use os.popen, so we can ignore stderr.
      (Closes: #336473)
    - If we fail to run a command, dprint out the problem.
  * Libchecks:
    - Rewrite transliterate, and a type of udeb should return udeb, not 
      binary. (Closes: #319746)
  * Manual Page:
    - Suck COMPARE WITH into SEE ALSO, and add dh_make(1) and debuild(1).
      (Closes: #322289)
  * Menu Parser:
    - Replace '\n' and '\' with ' '. (Closes: #325591, #326166)
  * Output:
    - Don't exit 1 if we only find warnings. (Closes: #337893)
  * Overrides:
    - Don't die a horrible death if we can't parse overrides.
    - Don't die if in-tarball overrides can't be parsed. (Closes: #339812)
  * Unpacking:
    - Don't die when we can't parse a .dsc.
    - Don't always try and mkdir the new directory, check that it doesn't
      exist first. (Closes: #338848)
  * BinaryCheck:
    - Consider files which are in a path that contains debug are meant for
      debugging. (Closes: #332746)
  * ControlCheck:
    - Remove package-b-d-on-autostar. (Closes: #327057)
    - Complain about a missing Section header in the first stanza of a
      source control file. (Closes: #322245)
  * DebhelperCheck:
    - Match python([0-9][0-9])?(-dev)?, not just python and python-dev.
      (Closes: #333514)
  * DocumentationCheck:
    - Only split off 1-8 for manual pages, not 0-9. (Closes: #319426)
  * LibraryCheck:
    - Deal with libdir's that end with a /. (Closes: #337627)
  * MenuCheck:
    - Correct typo in command-not-quoted. (Closes: #318919)
  * TruetypefontCheck:
    - New Check, thanks to Peter De Wachter. (Closes: #321775)
  * UDebBinaryCheck:
    - Correct the backward test for usr-doc-in-udeb.
  * UDebControlCheck:
    - Correct typo in section-not-di.

 -- Steve Kowalik <stevenk@debian.org>  Mon, 21 Nov 2005 22:47:38 +1100

linda (0.3.16) unstable; urgency=low

  * The "Yay for DebConf" release - all of the fixes below were done at
    DebConf5 in Helsinki.
  * ConfigFileParser:
    - Don't overwrite options that were provided on the command-line.
  * ControlParser:
    - Match on any whitespace between package name and relation in parsed
      fields.
    - Strip off whitespace and seperate brackets before trying to match.
  * Documentation:
    - Use epydoc to automatically generate some documentation.
    - Add python-epydoc to Build-Depends.
  * DpkgVersion:
    - Replace entirely with a version written by Scott James Remnant.
      (Closes: #315920) (thanks, Scott James Remnant)
  * Module, DataValidator:
    - Don't import arches in __init__, and get DataValidator to do it 
      itself.
  * Overrides:
    - Rewrote Data parsing so that it actually makes sense. (Closes: #316949) 
  * Packaging:
    - Bump Standards-Version to 3.6.2; no changes needed.
  * RFC822Parser:
    - Be able to remove the signed sections from a .changes that only has
      3 stanzas. (Closes: #316565)
  * Unpacker:
    - Fail unpacking if we can't read the tarball.
  * CDBSCheck:
    - Rewrite short description for cdbs-debhelper-build-dep-too-old.
      (Closes: #318289)
  * ChangesCheck, Udeb*Check:
    - Rewrite a few of the short or long description.
  * DpkgCheck:
    - No longer import commands.
  * FilesCheck:
    - Don't complain about ruby files under /usr/lib in an arch all package.

 -- Steve Kowalik <stevenk@debian.org>  Sun, 17 Jul 2005 16:39:02 +0300

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Priority: optional
 Section: devel
 Maintainer: Steve Kowalik <stevenk@debian.org>
-Build-Depends-Indep: python, debhelper (>= 4.0.0), file, dash, man-db
-Standards-Version: 3.6.1
+Build-Depends-Indep: python, debhelper (>= 4.0.0), file, dash, man-db, python-epydoc
+Standards-Version: 3.6.2
 
 Package: linda
 Architecture: all
-Depends: ${python:Depends}, binutils, file, dash, man-db
+Depends: ${python:Depends}, binutils, file, dash, man-db, dpkg-dev
 Recommends: debian-policy
 Suggests: binutils-multiarch, figlet
 Provides: lintian-python

=== debian/rules ===
--- 
+++ 
@@ -3,9 +3,13 @@
 build: build-stamp
 build-stamp:
 	dh_testdir
+	patch -p0 < debian/patches/01-gettext-langpacks.diff
+	patch -p0 < debian/patches/02-elf-information.diff
 	touch $@
 
 clean:
+	-patch -p0 -R -r /dev/null < debian/patches/02-elf-information.diff
+	-patch -p0 -R -r /dev/null < debian/patches/01-gettext-langpacks.diff
 	$(RM) -r build-stamp install-stamp test-stamp
 	$(RM) debian/copyright
 	$(MAKE) $@
@@ -14,7 +18,7 @@
 	dh_clean
 
 test: test-stamp
-test-stamp: install-stamp
+test-stamp: doc-stamp
 	$(MAKE) test DESTDIR="$(CURDIR)/debian/linda"
 	touch $@
 
@@ -25,7 +29,12 @@
 	$(MAKE) -C po install DESTDIR="$(CURDIR)/debian/linda"
 	touch $@
 
-binary-indep: build-stamp install-stamp test-stamp
+doc: doc-stamp
+doc-stamp: install-stamp
+	mkdir -p $(CURDIR)/debian/linda/usr/share/doc/linda/html
+	epydoc --no-frames --help-file doc/help.html -o $(CURDIR)/debian/linda/usr/share/doc/linda/html $(CURDIR)/debian/linda/usr/lib/site-python/linda
+
+binary-indep: build-stamp install-stamp doc-stamp test-stamp
 	dh_testroot
 	dh_installdirs
 	dh_installdocs -X.svn
